#!/usr/bin/perl
# save_group.cgi
# Update, create or delete a group

require './dhcpd-lib.pl';
require './params-lib.pl';
&ReadParse();
&lock_file($config{'dhcpd_conf'});
$par = &get_parent_config();
if ($in{'sidx'}) {
	$par = $par->{'members'}->[$in{'sidx'}];
	$indent++;
	}
if ($in{'uidx'}) {
	$par = $par->{'members'}->[$in{'uidx'}];
	$indent++;
	}
$parconf = $par->{'members'};
$group = $parconf->[$in{'idx'}] if (!$in{'new'});
if ($in{'delete'}) {
	# Delete this group
	$whatfailed = $text{'sgroup_faildel'};
	&save_directive($par, [ $group ], [ ], 0);
	}
elsif ($in{'options'}) {
	# Redirect to client options
	&redirect("edit_options.cgi?sidx=$in{'sidx'}&uidx=$in{'uidx'}&idx=$in{'idx'}");
	exit;
	}
else {
	$whatfailed = $text{'sgroup_failsave'};
	if ($in{'new'}) {
		# Create a new group
		$group->{'name'} = 'group';
		$group->{'type'} = 1;
		$group->{'members'} = [ ];
		}

	# Move hosts into or out of this group
	@wasin = &find("host", $group->{'members'});
	foreach $hn (split(/\0/, $in{'hosts'})) {
		if ($hn =~ /(\d+),(\d+)/) {
			push(@nowin, $parconf->[$2]->{'members'}->[$1]);
			$nowpr{$parconf->[$2]->{'members'}->[$1]} =
				$parconf->[$2];
			}
		elsif ($hn =~ /(\d+),/) {
			push(@nowin, $parconf->[$1]);
			$nowpr{$parconf->[$1]} = $par;
			}
		}
	foreach $h (&unique(@wasin, @nowin)) {
		$was = &indexof($h, @wasin) != -1;
		$now = &indexof($h, @nowin) != -1;
		if ($was && !$now) {
			# Move out of the group
			&save_directive($group, [ $h ], [ ], $indent);
			&save_directive($par, [ ], [ $h ], $indent);
			}
		elsif ($now && !$was) {
			# Move into the group (maybe from another group)
			&save_directive($nowpr{$h}, [ $h ], [ ], $indent);
			&save_directive($group, [ ], [ $h ], $indent + 1);
			}
		}

	# Validate and save inputs
	&save_choice("use-host-decl-names", $group, $indent+1);
	&parse_params($group, $indent+1);

	if ($in{'new'}) {
		# create this new group
		&save_directive($par, [ ], [ $group ], $indent);
		}
	}
&flush_file_lines();
&unlock_file($config{'dhcpd_conf'});
@count = &find("host", $group->{'members'});
&webmin_log($in{'delete'} ? 'delete' : $in{'new'} ? 'create' : 'modify',
	    'group', join(",", map { $_->{'values'}->[0] } @count), \%in);
&redirect("");

