#!/usr/bin/perl
# save_host.cgi
# Update, create or delete a host

require './dhcpd-lib.pl';
require './params-lib.pl';
&ReadParse();
&lock_file($config{'dhcpd_conf'});
$parent = &get_parent_config();
$conf = $parent->{'members'};
$level = 0;
$par = $parent;
foreach $i ($in{'sidx'}, $in{'uidx'}, $in{'gidx'}) {
	if ($i ne '') {
		$par = $par->{'members'}->[$i];
		$level++;
		}
	}
$host = $par->{'members'}->[$in{'idx'}] if (!$in{'new'});

if ($in{'delete'}) {
	# Delete this host
	$whatfailed = $text{'shost_faildel'};
	&save_directive($par, [ $host ], [ ], 0);
	}
elsif ($in{'options'}) {
	# Redirect to client options
	&redirect("edit_options.cgi?sidx=$in{'sidx'}&uidx=$in{'uidx'}&gidx=$in{'gidx'}&idx=$in{'idx'}");
	exit;
	}
else {
	$whatfailed = $text{'shost_failsave'};
	if ($in{'new'}) {
		# Creating a new structure
		$host->{'name'} = "host";
		$host->{'type'} = 1;
		$host->{'members'} = [ ];
		}

	# Validate and save inputs
	$in{'name'} =~ /^[A-z0-9\.\-]+$/ ||
		&error("'$in{'name'}' $text{'shost_invalidhn'}");
	$host->{'values'} = [ $in{'name'} ];

	if ($in{'hardware'}) {
		$in{'hardware'} =~ /^[0-9A-Fa-f:]+$/ ||
			&error(&text('shost_invalidhwa',$in{'hardware'},$in{'hardware_type'}) );
		@hard = ( { 'name' => 'hardware',
			    'values' => [ $in{'hardware_type'},
					  $in{'hardware'} ] } );
		}
	&save_directive($host, 'hardware', \@hard);

	if ($in{'fixed-address'}) {
		@fixedip = split(/\s+/, $in{'fixed-address'});
		@fixed = ( { 'name' => 'fixed-address',
			     'values' => [ join(" , ", @fixedip) ] } );
		}
	&save_directive($host, 'fixed-address', \@fixed);

	&parse_params($host);

	if ($in{'new'}) {
		# Add to the end of the parent structure
		&save_directive($par, [ ], [ $host ], $level);
		}
	else {
		# Update host
		&save_directive($par, [ $host ], [ $host ], $level);
		}
	}
&flush_file_lines();
&unlock_file($config{'dhcpd_conf'});
&webmin_log($in{'delete'} ? 'delete' : $in{'new'} ? 'create' : 'modify',
	    'host', $host->{'values'}->[0], \%in);
&redirect("");

