#!/usr/bin/perl
# save_fshare.cgi
# Save a new or edited file share

require './samba-lib.pl';
$whatfailed = $text{'savefshare_fail'};
&ReadParse();
&lock_file($config{'smb_conf'});
if ($in{old_name}) {
	&get_share($in{old_name});
	}

# store share options
if ($in{old_name} eq "global") {
	$name = "global";
	}
else {
	$name = $in{"homes"} ? "homes" : $in{"share"};
	if ($in{"path"} !~ /\S/ && !$in{"homes"}) {
		&error($text{'savefshare_nopath'});
		}
	}
&setval("path", $in{"path"});
&setval("available", $in{"available"});
&setval("browseable", $in{"browseable"});
&setval("comment", $in{"comment"});

# Check for clash
if ($name ne "global") {
	foreach (&list_shares()) {
		$exists{$_}++;
		}
	if (!$in{old_name} && $exists{$name}) {
		&error(&text('savefshare_exist', $name));
		}
	elsif ($in{old_name} ne $name && $exists{$name}) {
		&error(&text('savefshare_exist', $name));
		}
	elsif ($name !~ /^[A-z0-9_\$ ]+$/) {
		&error(&text('savefshare_mode', $name));
		}
	elsif ($name eq "global") {
		&error($text{'savefshare_global'});
		}
	}

# Update config file
if ($in{old_name}) {
	# Changing an existing share
	&modify_share($in{old_name}, $name);
	}
else {
	# Creating a new share
	&create_share($name);
	}
&unlock_file($config{'smb_conf'});
&webmin_log($in{old_name} ? "save" : "create", "fshare", $name, \%in);
&redirect("");

