#!/usr/bin/perl
# autoreply.pl
# Simple autoreply script

# read sendmail module config
$p = -l $0 ? readlink($0) : $0;
$p =~ /^(.*)\/[^\/]+$/;
open(CONF, "$1/config");
while(<CONF>) {
	if (/^(\S+)=(.*)/) {
		$config{$1} = $2;
		}
	}
close(CONF);

# read headers and body
while(<STDIN>) {
	s/\r|\n//g;
	if (/^(\S+):\s+(.*)/) {
		$header{lc($1)} = $2;
		}
	elsif (!$_) { last; }
	}
while(<STDIN>) {
	$body .= $_;
	}
if ($header{'from'} =~ /mailer-daemon/i) {
	print STDERR "Cancelling autoreply to bounced email\n";
	exit 1;
	}
if ($header{'x-webmin-autoreply'}) {
	print STDERR "Cancelling autoreply to an autoreply\n";
	exit 1;
	}

# work out the correct to address
@to = split(/\s*,\s*/, $header{'to'});
$to = $to[0];
foreach $t (@to) {
	if ($t =~ /([^<>\s,'"\@]+)\@([A-z0-9\-\.\!]+)/ && $1 eq $ARGV[1]) {
		$to = $t;
		}
	}

# run sendmail to reply
open(MAIL, "|$config{'sendmail_path'} -t");
print MAIL "From: $to\n";
if ($header{'reply-to'}) {
	print MAIL "To: $header{'reply-to'}\n";
	}
else {
	print MAIL "To: $header{'from'}\n";
	}
print MAIL "Subject: Autoreply to $header{'subject'}\n";
print MAIL "X-Webmin-Autoreply: 1\n";
print MAIL "X-Originally-To: $header{'to'}\n";
print MAIL "X-Originally-To-List: ",join("|", @to),"\n";
print MAIL "\n";
if (open(AUTO, $ARGV[0])) {
	while(<AUTO>) {
		s/\$SUBJECT/$header{'subject'}/g;
		s/\$FROM/$header{'from'}/g;
		s/\$TO/$to/g;
		s/\$DATE/$header{'date'}/g;
		s/\$BODY/$body/g;
		print MAIL $_;
		}
	close(AUTO);
	}
else {
	print MAIL "Autoreply file $ARGV[0] does not exist!\n";
	}
close(MAIL);

