# bind8-monitor.pl
# Monitor the BIND DNS server on this host

&foreign_require("bind8", "bind8-lib.pl");

# Check the PID file to see if apache is running
sub get_bind8_status
{
local %bconfig = &foreign_config("bind8");
return { 'up' => -1 } if (!-r $bconfig{'chroot'}.$bconfig{'named_conf'});
local $conf = &foreign_call("bind8", "get_config");
local $opts = &foreign_call("bind8", "find", "options", $conf);
local $pidopt = &foreign_call("bind8", "find", "pid-file", $opts->{'members'});
local $file = $pidopt ? $pidopt->{'value'} :
	      $bconfig{'pid_file'} ? $bconfig{'pid_file'} :
	      "/var/run/named.pid";

if (open(PID, $file) && <PID> =~ /(\d+)/ && kill(0, $1)) {
	close(PID);
	local @st = stat($file);
	return { 'up' => 1,
		 'desc' => &text('up_since', scalar(localtime($st[9]))) };
	}
else {
	return { 'up' => 0 };
	}
}

sub parse_bind8_dialog
{
&depends_check($_[0], "bind8");
}

1;

